precision mediump float;
varying vec2 mapTexCoords;
uniform sampler2D coverageTex;
uniform sampler2D mapTex1;
uniform sampler2D mapTex2;
uniform sampler2D scaleTex;
uniform float alpha;
uniform vec2 phi;
float val;
float val255;
float coverage;
float val0;
float val1;
vec4 col;
vec2 scaleTexCoords;
void main() {

    coverage = texture2D(coverageTex, mapTexCoords)[3];

    if (coverage <= 0.0) {
        col = vec4(0.1, 0.1, 0.1, 0.2);

    } else {

        bool isSnow = false;
        val0 = 255.0 * texture2D(mapTex1, mapTexCoords)[3];
        val1 = 255.0 * texture2D(mapTex2, mapTexCoords)[3];

        if (val0 > 127.0) {
            val0 -= 127.0;
            if (phi[0] > phi[1]) {
                isSnow = true;
            }
        }
        if (val1 > 127.0) {
            val1 -= 127.0;
            if (phi[1] > phi[0]) {
                isSnow = true;
            }
        }
        if (val0 < 1.0 || val1 < 1.0) {
            col = vec4(0.0, 0.0, 0.0, 0.0);

        } else {

            val255 = phi[0] * val0 + phi[1] * val1;
            //val = (val255 - 31.0) / 95.0;  // full range
            val = (val255 - 31.0) / 80.0;


            float texIndex = 9.5;
            if (isSnow) {
                texIndex = 56.5;
            }

            scaleTexCoords = vec2(val, texIndex / 100.0);
            col = texture2D(scaleTex, scaleTexCoords);

        }
    }

    gl_FragColor = vec4(col[0], col[1], col[2], alpha * col[3]);

}